
We consider manipulating symbolic data structure within usual machine learning algorithms, for instance considering a reactive system engaged in some open-ended ill-defined problem-solving task. We define problem-solving task at a geometric level, considering being located somewhere in a state-space, with the goal of reaching some final (unique or alternative, eventually partially defined) state, finding a way from the former to the latter, while satisfying the path constraints. Here the goal is has to be specified as part of the task, and the state space is to be explored and discovered, as illustrated in Fig.~\ref{problem-solving-as-trajectory}.

\begin{figure}[htb]
\centerline{\includegraphics[width=0.9\textwidth]{./problem-solving-as-trajectory.png}}
\caption{Formalizing Problem Solving as a Trajectory Generation Problem in an Abstract State Space.
Given, for instance, for the CreaCube robotic open-ended problem-solving task \cite{romero_creacube_2019}, the initial state corresponds to the initial setup, path states to exploration or partial construction of the solution, path constraint to inappropriate configuration (here the cube tower falls down) and goal state to some (not unique) solution, while several paths are possible regarding such an open problem. Since the problem is ill-defined, the state space is not known from the beginning but discovered when solving it. Each point in this abstract state space is not numeric but corresponds to a symbolic description of the scene, as developed in the text. This can be linked to a notion of reward, null at the initial state, unbounded and negative of obstacles and unbounded and postive when a goal is reached.} \label{problem-solving-as-trajectory}
\end{figure}
  
The pivotal idea of this geometric definition is to consider an abstract state space where each point is a symbolic data structure, representing contextual information about the physical space and about the agent internal state. Selecting a local trajectory corresponds to deciding, as a step in the problem-solving process, to modify some characteristics of the state space both at the external level (e.g., moving an object) and at the internal level (i.e., modifying the internal representation).

In order to illustrate this formalism at the algorithmic level, in Appendix B, we generalize to symbolic data structures the algorithm developed in \cite{vieville_improved_2002}. A set of regions (or points) corresponding to obstacles or goals and a current state value is given. Goals can be ``weighted'', i.e., given with a certain reward value that corresponds to their importance. Similarly obstacles can be weighted, i.e., given with a certain repulsion value that corresponds to the importance to avoid them. The algorithm reduce to the maximization of the explicit scalar function of the symbolic data-structures, i.e., scalar-field, written:
\eqline{V({\bf x}) \deq \sum_i V_i({\bf x}) - \gamma \, \sum_j V_j({\bf x}), V_i({\bf x}) \deq \frac{\omega({\bf x}_i)}{\delta({\bf x}, {\bf x}_i)}, \omega(\dot) > 0}
where ${\bf x}_i$ and ${\bf x}_j$ are points respectively sampled by projection on the goal regions and on the obstacles or constraints regions by the algorithm. We always can choose $\omega(\dot) = 1$ as default value, if there is no benefit to introduce a-priory information at this stage. It is obvious to verify that such a potential corresponds up to a constant to a the reward represented in Fig.~\ref{problem-solving-as-trajectory}, while it attains a maximum on a goal state. What is less obvious but developed in Appendix B, is that this potential can be defined without local maxima, and maximized even when sampled on continuous goal and obstacle regions.


